# ***********************************************
# 
# !!!! DO NOT EDIT !!!!
# 
# This file was auto-generated by Build.PL.
# 
# ***********************************************
# 
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

=encoding utf8

=head1 NAME

Lucy::Search::PolySearcher - Aggregate results from multiple Searchers.

=head1 SYNOPSIS

    my $schema = MySchema->new;
    for my $index (@index_paths) {
        push @searchers, Lucy::Search::IndexSearcher->new( index => $index );
    }
    my $poly_searcher = Lucy::Search::PolySearcher->new(
        schema    => $schema,
        searchers => \@searchers,
    );
    my $hits = $poly_searcher->hits( query => $query );

=head1 DESCRIPTION

The primary use for PolySearcher is to aggregate results from several
indexes on a single machine.

=head1 CONSTRUCTORS

=head2 new

    my $poly_searcher = Lucy::Search::PolySearcher->new(
        schema    => $schema,
        searchers => \@searchers,
    );

Create a new PolySearcher.

=over

=item *

B<schema> - A Schema.

=item *

B<searchers> - An array of Searchers.

=back

=head1 METHODS

=head2 doc_max

    my $int = $poly_searcher->doc_max();

Return the maximum number of docs in the collection represented by the
Searcher, which is also the highest possible internal doc id.
Documents which have been marked as deleted but not yet purged are
included in this count.

=head2 doc_freq

    my $int = $poly_searcher->doc_freq(
        field => $field  # required
        term  => $term   # required
    );

Return the number of documents which contain the term in the given
field.

=over

=item *

B<field> - Field name.

=item *

B<term> - The term to look up.

=back

=head2 collect

    $poly_searcher->collect(
        query     => $query      # required
        collector => $collector  # required
    );

Iterate over hits, feeding them into a
L<Collector|Lucy::Search::Collector>.

=over

=item *

B<query> - A Query.

=item *

B<collector> - A Collector.

=back

=head2 fetch_doc

    my $hit_doc = $poly_searcher->fetch_doc($doc_id);

Retrieve a document.  Throws an error if the doc id is out of range.

=over

=item *

B<doc_id> - A document id.

=back

=head1 INHERITANCE

Lucy::Search::PolySearcher isa L<Lucy::Search::Searcher> isa Clownfish::Obj.

=cut

